########Data Source: http://anson.ucdavis.edu/~mueller/data/data.html
require("ECF");
source("FSHK.R")
L=49;
fb = TRUE;
if(fb == TRUE){
  basis <- create.fourier.basis(c(0,1),L);
}else{
  basis <- create.bspline.basis(c(0,1),L);
}

medfpans <- read.table("medfpnas.dat", header = FALSE, sep = "");
meddata <- medfpans[1:202,];

x1=matrix(0,100,33);#101
x2=matrix(0,100,33);#101
x3=matrix(0,100,33);#101
x4=matrix(0,100,33);#101
for (i in 1:33)
{
  x1[,i]=meddata[2:101,i+1]/meddata[1,i+1];#males on sugar diet%1:101
  x2[,i]=meddata[2:101,35+i]/meddata[1,35+i];#males on sugar and protein diet
  x3[,i]=meddata[103:202,i+1]/meddata[102,i+1];#females on sugar diet%102:202
  x4[,i]=meddata[103:202,35+i]/meddata[102,35+i];#females on sugar and protein diet
}
y2=x2[1:30,];# males on sugar and protein diet
y4=x4[1:30,];#females on sugar and protein diet
y1=x1[1:30,];# males on sugar diet
y3=x3[1:30,];#females on sugar diet

#compare gender effect on full diet
datamx <- cbind(y2,y4);
sample_n <- c(dim(y2)[2],dim(y4)[2]);
PV_1 <- ECFL2Rcpp(datamx,sample_n, approx=1, centered = 0);#L2br
PV_2 <- rcpparma_ECFL2RP(datamx,sample_n, 500, 0);#L2rp
PV_3 <- rcpparma_ECFL2maxRP(datamx,sample_n, 500, 0);#Tmax
PV_4 <- ECFFnaiveRcpp(datamx,sample_n,centered=0);#GPFnv
PV_5 <- rcpparma_ECFFRP(datamx,sample_n,500,0);#GPFrp
PV_6 <- rcpparma_ECFFmaxRP(datamx,sample_n,500,0);#Fmax,rp
PV_78 <- FSHK(y2,y4,basis,dper=0.9,centered=0);#FSHK1,2
pvalues <- c(PV_1[2],PV_2,PV_3,PV_4[2],PV_5,PV_6,PV_78[c(3,4)]);
print("Group 1 vs Group 2");
print(pvalues*100);

#compare gender effect on reduced diet
datamx <- cbind(y1,y3);
sample_n <- c(dim(y1)[2],dim(y3)[2]);
PV_1 <- ECFL2Rcpp(datamx,sample_n, approx=1, centered = 0);
PV_2 <- rcpparma_ECFL2RP(datamx,sample_n, 500, 0);
PV_3 <- rcpparma_ECFL2maxRP(datamx,sample_n, 500, 0);
PV_4 <- ECFFnaiveRcpp(datamx,sample_n,centered=0);
PV_5 <- rcpparma_ECFFRP(datamx,sample_n,500,0);
PV_6 <- rcpparma_ECFFmaxRP(datamx,sample_n,500,0);
PV_78 <- FSHK(y1,y3,basis,dper=0.9,centered=0);
pvalues <- c(PV_1[2],PV_2,PV_3,PV_4[2],PV_5,PV_6,PV_78[c(3,4)]);
print("Group 1 vs Group 3");
print(pvalues*100);

#compare diet effect on female
datamx <- cbind(y3,y4);
sample_n <- c(dim(y3)[2],dim(y4)[2]);
PV_1 <- ECFL2Rcpp(datamx,sample_n, approx=1, centered = 0);
PV_2 <- rcpparma_ECFL2RP(datamx,sample_n, 500, 0);
PV_3 <- rcpparma_ECFL2maxRP(datamx,sample_n, 500, 0);
PV_4 <- ECFFnaiveRcpp(datamx,sample_n,centered=0);
PV_5 <- rcpparma_ECFFRP(datamx,sample_n,500,0);
PV_6 <- rcpparma_ECFFmaxRP(datamx,sample_n,500,0);
PV_78 <- FSHK(y3,y4,basis,dper=0.9,centered=0);
pvalues <- c(PV_1[2],PV_2,PV_3,PV_4[2],PV_5,PV_6,PV_78[c(3,4)]);
print("Group 3 vs Group 4");
print(pvalues*100);

#compare diet effect on male
datamx <- cbind(y1,y2);
sample_n <- c(dim(y1)[2],dim(y2)[2]);
PV_1 <- ECFL2Rcpp(datamx,sample_n, approx=1, centered = 0);
PV_2 <- rcpparma_ECFL2RP(datamx,sample_n, 500, 0);
PV_3 <- rcpparma_ECFL2maxRP(datamx,sample_n, 500, 0);
PV_4 <- ECFFnaiveRcpp(datamx,sample_n,centered=0);
PV_5 <- rcpparma_ECFFRP(datamx,sample_n,500,0);
PV_6 <- rcpparma_ECFFmaxRP(datamx,sample_n,500,0);
PV_78 <- FSHK(y1,y2,basis,dper=0.9,centered=0);
pvalues <- c(PV_1[2],PV_2,PV_3,PV_4[2],PV_5,PV_6,PV_78[c(3,4)]);
print("Group 1 vs Group 2");
print(pvalues*100);

#compare all the four groups
datamx <- cbind(y1,y2,y3,y4);
sample_n <- c(dim(y1)[2],dim(y2)[2],dim(y3)[2],dim(y4)[2]);
PV_1 <- ECFL2Rcpp(datamx,sample_n, approx=1, centered = 0);
PV_2 <- rcpparma_ECFL2RP(datamx,sample_n, 500, 0);
PV_3 <- rcpparma_ECFL2maxRP(datamx,sample_n, 500, 0);
PV_4 <- ECFFnaiveRcpp(datamx,sample_n,centered=0);
PV_5 <- rcpparma_ECFFRP(datamx,sample_n,500,0);
PV_6 <- rcpparma_ECFFmaxRP(datamx,sample_n,500,0);
#PV_78 <- FSHK(y1,y2,basis,dper=0.9,centered=0);
pvalues <- c(PV_1[2],PV_2,PV_3,PV_4[2],PV_5,PV_6);
print("All the four groups");
print(pvalues*100);