########Methods of Fremdt, S., Steinebach, J. G., Horváth, L., and Kokoszka, P. (2013).
FSHK <- function(e1,e2,basis,dper=0.9,centered=0)
{
  require('fBasics');
  require('fda');
  dim1 <- dim(e1);
  sampling_points <- dim(e1)[1]-1;
  N <- dim(e1)[2];
  M <- dim(e2)[2];
  
  if(centered==0)
  {
    e1_bar <- matrix(0,sampling_points + 1,1);    #initializing sume
    e2_bar <- matrix(0,sampling_points + 1,1);		#initializing sume
    e1_bar <- 1 / N * (rowSums(e1));
    e2_bar <- 1 / M * (rowSums(e2));
    e1_bar_matrix <- matrix(e1_bar,(sampling_points + 1),N);
    e2_bar_matrix <- matrix(e2_bar,(sampling_points + 1),M);
    X1 <- matrix(,(sampling_points + 1),N);
    X2 <- matrix(,(sampling_points + 1),M);
    X1 <- (e1 - e1_bar_matrix);
    X2 <- (e2 - e2_bar_matrix);
  }else{
    X1 <- e1;
    X2 <- e2;
  }
  
  Ycom  <- matrix(,(sampling_points + 1),(N + M));					#preallocation
  Ycom[,1:N] =  X1;
  Ycom[,(N + 1):(N + M)] =  X2;
  Y = sqrt((N + M - 1) / (N + M)) * Ycom;
  
  t = (0:(sampling_points)) / sampling_points;
  functional_X1 = Data2fd(y = X1,argvals = t,basis);
  functional_X2 = Data2fd(y = X2,argvals = t,basis);
  functional_Y = Data2fd(y = Y,argvals = t,basis);
  
  if(dper<1)
  {
    #per <- dper;
    #L <- basis$nbasis;
    pca <- pca.fd(functional_Y,nharm = 1, centerfns = FALSE);
    alleigenvalues <- pca$values;
    neigenvalues <- length(alleigenvalues);
    #sumeigenvalues <- sum(alleigenvalues);
    #pereigenvalues <- alleigenvalues/sumeigenvalues;
    pereigenvalues <- alleigenvalues/sum(alleigenvalues);
    
    psum <- 0.0;
    d <- neigenvalues;
    for(i in 1:neigenvalues)
    {
      psum <- psum+pereigenvalues[i];
      if(psum>dper)
      {
        d <- i;break;
      }
    }#end of for(i in 1:neigenvalues)
  }else{
    d <- dper;
  }
  pca = pca.fd(functional_Y,nharm = d, centerfns = FALSE);
  eigenfunctions = pca$harmonics;
  eigenvalues = pca$values[1:d];#sum(pca$values[1:5])/sum(pca$values), minimum~0
  per <- sum(eigenvalues)/sum(pca$values);
  
  a <- matrix(0,d,N)
  for (k in 1:N) {
    a[,k] <- inprod(functional_X1[k], eigenfunctions)
  }
  
  ast <- matrix(0,d,M)
  for (k in 1:M) {
    ast[,k] <- inprod(functional_X2[k], eigenfunctions)
  }
  
  DN <- matrix(0,d,d)
  DM <- matrix(0,d,d)
  for (i in 1:d) {
    for (j in 1:i) {
      DN[i,j] <- (sum(a[i,] * a[j,])) / N
      DM[i,j] <- (sum(ast[i,] * ast[j,])) / M
    }
  }
  
  Diff <- DN - DM
  
  Xi <- vech(Diff)
  
  T <- N / (N + M)
  
  K <- d * (d + 1) / 2
  
  LH <- matrix(0,K,K)
  
  L1 <- matrix(0,K,K)
  L2 <- matrix(0,K,K)
  
  
  for (k in 1:K) {
    j <- d - ceiling(sqrt(d * (d + 1) - 2 * k + 2.25) - 0.5) + 1
    i <- k + d - d * j + j * (j - 1) / 2
    for (kp in 1:k) {
      jp <- d - ceiling(sqrt(d * (d + 1) - 2 * kp + 2.25) - 0.5) + 1
      ip <- kp + d - d * jp + jp * (jp - 1) / 2
      L1[k,kp] <- (sum(a[i,] * a[j,] * a[ip,] * a[jp,])) / N
      L2[k,kp] <- (sum(ast[i,] * ast[j,] * ast[ip,] * ast[jp,])) / M
      if (i == j && ip == jp) {
        L1[k,kp] <- L1[k,kp] - eigenvalues[i] * eigenvalues[ip]
        L2[k,kp] <- L2[k,kp] - eigenvalues[i] * eigenvalues[ip]
      }
      LH[k,kp] <- (1 - T) * L1[k,kp] + T * L2[k,kp]
      LH[kp,k] <- LH[k,kp]
    }
  }
  
  Linv <- try(solve(LH))
  if (class(Linv) == "try-error") {
    print("LH singular!")
    Linv <- ginv(LH)
  }
  CP2 <- crossprod(Linv,t(Xi))
  T1 <- M * T * (crossprod(t(Xi),CP2))
  
  B <- Diff ^ 2 / (crossprod(t(eigenvalues),t(eigenvalues)))
  B <- B * (matrix(1,d,d) - 0.5 * diag(d))
  T2 <- M * T * (sum(B[lower.tri(B,TRUE)]))
  
  df <- d*(d+1)/2;
  pv1 <- pchisq(q = T1, df = df, lower.tail = FALSE);
  pv2 <- pchisq(q = T2, df = df, lower.tail = FALSE);
  return(c(T1,T2,pv1,pv2,d,per));
}