#########The main simulation file
vdelta = c(0,vdelta);

filenamecommon <- paste(path, "samplesize=", sample_n[1], "_rho=", rho, "_datatype=", dflag, sep ="");
print(filenamecommon);

k = length(sample_n); # k is the group number
#sample_num = c(20,30,30);#	the size of the k sample.
#	determines the number of points at which the error term will be defined.
sample_p = 80;#80#180;
#number of the fourier basis
dtd=11;#21;#q
a=1.5;
#	The number of times the test is performed with with each c.
#repetitions = 100;#1000
time=0:(sample_p-1)/(sample_p-1);#(0:(p-1))/(p-1);
#require('fda');
L=49;
fb = TRUE;
if(fb == TRUE){
  dbasis <- create.fourier.basis(c(0,1),dtd);
  basis <- create.fourier.basis(c(0,1),L);
}else{ 
  dbasis <- create.bspline.basis(c(0,1),dtd);
  basis <- create.bspline.basis(c(0,1),L);
} 

psi <- eval.basis(time,dbasis);#pxr
dpsi <- matrix(0,sample_p,dtd);
#dpsi[,2] <- rep(1,sample_p);#diff at the second eigen function
#or
#https://en.wikipedia.org/wiki/Dirac_delta_function
#dnorm(x, mean = 0, sd = 1, log = FALSE)
Dirac <- dnorm(time, mean = 0, sd = 1/8);#dnorm(0:(dtd-1)/dtd, mean = 0, sd = 1/8);
#dpis[,1] <- Dirac;#sparse diff at the first eigen function
#or
#dpis[,2] <- time;#scale diff diff at the second eigen function
#above is equivalent to using constant diff but with psi has scale diff
#or
dpsi[,2] <- rep(1,sample_p);
########Switch between the settings of Simulations 1,2 and 3,4
scalediff=TRUE;#FALSE
if(scalediff)
{
  scale <- (sample_p-1)/(1:sample_p);#sin(2*pi*(1:sample_p)/sample_p);#
  psi <- apply(psi, 2, '*', scale);
}

#u <- matrix(,sample_p,dtd);
#rho=0.3;
di <- rep(0,dtd);
for(r in 1:dtd){
  di[r]=rho^(r-1);
  #u[,r]=time^(r-1);
}
di<-sqrt(a*di);

ddi<-rep(0,dtd);
ddi[dtd]<-1;#diff at the last eigen value

#set the mean functions
#Currently, mean use different method (mean matrix) from cov to set the diff
#to allow different initial means of the k samples
#Future, cov should use the same method to allow initial covs of the k samples
eta <- matrix(0,sample_p,k);#eta matrix
# ec1 <- 1:dtd;#matrix(,d,1);
# ec2 <- (1:dtd)/2;
# #ec3 <- (1:dtd)/4;
# eta[,1] <- u %*% ec1;#sampling_points*dtd*dtd*1=sampling_points*1;
# eta[,2] <- u %*% ec2;#
# #eta[,3] <- u %*% ec3;#
deta <- rep(0,sample_p);#matrix(rep(0,sample_p),sample_p,1);#no diff
# we simply set eta=0 instead!
# u <- c(1,2,3,4)/sqrt(30);
# c1 <- c(1,2.3,3.4,1.5);
# for(i in 1:k)
# {
#   ci <- c1+0.1*(i-1)*u;
#   eta[,i]<- ci[1]+ci[2]*time+ci[3]*(time^2)+ci[4]*(time^3);
# }


#	The size of the test. This is used in determining the proportion of times we reject.
alpha = 0.05;
methodnames = c("L2nv","L2br","L2rp","Tmax","Fnaive","Frp","Fmax");
#c("FSHK1-0.9","FSHK2-0.9","Fnaive","L2rp", "L2max","Frp", "Fmax");
#c("L2-NV","L2-BR","L2-RP","L2-MAX");
nmethod = length(methodnames);

#vdelta = c(seq(1,4,0.2),8,10,20);#simple sample sizes#seq(1,3.2,0.4);#control the difference of the K sample
ndelta = length(vdelta);
pv = matrix(,nmethod,ndelta);#means
pvvar = matrix(,nmethod,ndelta);#vars
for (i in 1:ndelta)
{
  delta <- vdelta[i];
  pv_all <-
    foreach(rep_index = 1:repetitions,.combine = rbind) %dopar% OneRun(sample_n,sample_p,dtd,di,ddi,psi,dpsi,eta,deta,delta,dflag,basis);
  
  pv[,i] = colMeans(pv_all < alpha);
  pvvar[,i] = apply(pv_all<alpha, 2, var);
  
  print(paste("for delta =", vdelta[i], "powers are:"));
  print(pv[,i]);
  
  if (sum(pv[,i]) == nmethod && i != ndelta)
  {
    pv[,(i + 1):ndelta] <- 1;
    break;
  }
}
powertable <- t(rbind(vdelta,pv));
powervartable <- t(rbind(vdelta,pvvar));

colnames(powertable) <- c("delta",methodnames);
write.csv(
  powertable, file = paste(filenamecommon,".csv",sep=""),
  row.names = FALSE
);

saveRDS(powertable, file=paste(filenamecommon,".rds",sep=""));
saveRDS(powervartable, file=paste(filenamecommon,"_var.rds",sep=""));