########Generate simulated discrete functional data matrix
fdata <- function(n,dtd,di,psi,dflag,df=5)
{
  require("sde");
  #return pxn data matrix
  #dflag=CN, CT, BB, BM, NG
  p <- dim(psi)[1];
  mx <- matrix(,dtd,n);
  if(dflag=="CN")
  {
    #for(r in 1:dtd){mx[r,]=di[r]*rnorm(n,0,1);}
    mx <- apply(matrix(rnorm(dtd * n, 0, 1), dtd, n), 2, '*', di);
    mx <- psi%*%mx;
  }else if(dflag=="CT"){
    #for(r in 1:dtd){mx[r,]=di[r]*rt(n,4)/sqrt(2);}
    #originally use dof 4 t-dis
    #mx <- apply(matrix(rt(dtd * n, 4), dtd, n)/sqrt(2), 2, '*', di);
    #now use dof 5!!!
    mx <- apply(matrix(rt(dtd * n, 5), dtd, n)/sqrt(5/3), 2, '*', di);
    mx <- psi%*%mx;
    #y=(eta)%*%rep(1,n)+psi%*%mx;
    #y=matrix(eta,dtd,n)+psi%*%mx;
  }else if(dflag=="BB"){
    mx <- matrix(,p,n);
    for (index in 1:n)
    { 
      mx[,index] <- as.matrix(BBridge(x=0, y=0, t0=0, T=1, N=p-1));
    }
  }else if(dflag=="BM"){
    mx <- matrix(,p,n);
    for (index in 1:n)
    {
      mx[,index] <- as.matrix(BM(x=0, t0=0, T=1, N=p-1));
    }
  }else if(dflag=="NG"){
    mx <- matrix(,p,n);
    for (index in 1:n)
    {
      T <- rt(3,df);
      t = (0:(p-1))/(p-1);
      Xs <-5*T[1]*sin(pi*t)+3*T[2]*sin(2*pi*t)+T[3]*sin(4*pi*t);
      mx[,index] <- as.matrix(Xs);
    }
  }else if(dflag=="NGnew"){
    mx <- matrix(,p,n);
    for (index in 1:n)
    {
      VW <- rt(20,df);
      t = (0:(p-1))/(p-1);
      Xs <- rep(0,p);
      for(k in 1:10)
      {
        Xs <- Xs+VW[k]*sqrt(2)/sqrt(k)*sin(pi*k*t)+VW[10+k]/sqrt(k)*cos(2*pi*k*t);
      }
      mx[,index] <- as.matrix(Xs);
    }
  }else if(dflag=="NGnew48"){
    mx <- matrix(,p,n);
    for (index in 1:n)
    {
      VW <- rt(48,df);
      t = (0:(p-1))/(p-1);
      Xs <- rep(0,p);
      for(k in 1:24)
      {
        Xs <- Xs+VW[k]*sqrt(2)/sqrt(k)*sin(pi*k*t)+VW[24+k]/sqrt(k)*cos(2*pi*k*t);
      }
      mx[,index] <- as.matrix(Xs);
    }
  }else if(dflag=="NGnew96"){
    mx <- matrix(,p,n);
    for (index in 1:n)
    {
      VW <- rt(96,df);
      t = (0:(p-1))/(p-1);
      Xs <- rep(0,p);
      for(k in 1:48)
      {
        Xs <- Xs+VW[k]*sqrt(2)/sqrt(k)*sin(pi*k*t)+VW[48+k]/sqrt(k)*cos(2*pi*k*t);
      }
      mx[,index] <- as.matrix(Xs);
    }
  }

  return(mx);
}